package bank;



/**
 * Class that represents the central host of our bank. This class manages the
 * persistent information about accounts and is responsible for creating new
 * accounts and issuing bank cards
 */
public class CentralHost {

    /**
     * Maximum account number.
     */
    public static final int maxAccountNumber = 10000;


    /**
     * @return the singleton instance
     */
    public static CentralHost getInstance () {
    }


    /**
     * Obtain the account with number <code>accountNumber</code>
     * 
     * @param accountNumber
     *            the number of the account that is requested
     * @return the account with number <code>accountNumber</code>, or
     *         <code>null</code> iff no such account exists
     */
    public PermanentAccount getAccount (int accountNumber) {
    }


    /**
     * @return <code>true</code> iff there is an account with number
     *         <code>accountNumber</code>
     */
    public boolean accountExists (int accountNumber) {
    }


    /**
     * Create a new account with account number <code>accountNumber</code>
     * 
     * @param accountNumber
     *            the number of the account to be created
     */
    public void createAccount (int accountNumber) {
    }


    /**
     * Issue a bank card for the account with number <code>accountNumber</code>
     * and setup the card with the given PIN
     * 
     * @param accountNumber
     *            number of the account for which a card is supposed to be
     *            issued
     * @param pin
     *            the PIN of the card to be issued
     * @return the software bank card representation
     */
    public BankCard issueCard (final int accountNumber, int pin) {
    }


    /**
     * Reactivate an invalidated card.
     * 
     * @param card the card to reactivate, the corresponding account must
     *         exist
     */
    public void reactivateCard (BankCard card) {
    }


    public String toString () {
    }
}
